#ifndef DISKDUMP_FORMAT_H
#define DISKDUMP_FORMAT_H

/* $Id: diskdump_format.h,v 1.24 2005/02/25 23:15:51 akira Exp $ */

#include "diskdumpcmn.h"

#define DISKDUMP_FORMAT_VER_0		0
#define DISKDUMP_FORMAT_VER_1		1
#define CURRENT_DISKDUMP_FORMAT_VER	DISKDUMP_FORMAT_VER_1

#define MINIMUM_FORMAT_SIZE	5

#define FORMATTED		0
#define HAS_PANIC_DUMP		1
#define NOT_A_DUMP_DEVICE	2
#define FORMAT_REQUIRED		3
#define NOT_SUITABLE_DEVICE	4

typedef struct format_params {
	char	signature[SIG_LEN];
	int32_t	block_number;
	int32_t	fmt_version;
	int32_t	sample_rate;
	int32_t	block_order;
	int64_t	format_size;
	char	cmd_version[32];
} format_params_t;

typedef struct dump_device {
	const char	*name;
	int		 fd;
	int		 page_size;
	off_t		 block_size;
	bool		 do_progress;
	format_params_t	*dev;
	format_params_t	*req;
	void		*scratch;
	bool		 broken_header;
	bool		 is_dump_device;
	bool		 has_panic_dump;
	bool		 ver0_formatted;
	char		*err_msg;
	char		*reason;
	char		*status;
} dump_device_t;

int		 get_module_params(dump_device_t *, int mod_path);
int		 check_device(dump_device_t *);
void		 show_device_info(dump_device_t *, int status, bool verbose);
void		 show_format_info(dump_device_t *, bool verbose);
dump_device_t	*alloc_device(void);
int		 open_device(dump_device_t *, const char *name);
off_t		 format_device(dump_device_t *);
bool		 enough_block_size(dump_device_t *);

#endif
