#ifndef DISKDUMPCMN_H
#define DISKDUMPCMN_H

/* $Id: diskdumpcmn.h,v 1.2 2005/02/25 20:59:44 akira Exp $ */

#define DUMP_PARTITION_SIGNATURE	"diskdump"
#define SIG_LEN	(sizeof(DUMP_PARTITION_SIGNATURE) - 1)
#define DISK_DUMP_SIGNATURE		"DISKDUMP"

#define FAILED		-1
#define SUCCEEDED	0

#define INVALID_MODULE_ID	-1
#define PROC_DISKDUMP		0	/* kernel-2.4.x */
#define SYS_MODULE_DISKDUMP	1
#define SYS_MODULE_PARAMETERS	2	/* kernel-2.6.10 */
 
#define Err(x, ...) fprintf(stderr, "%s: " x, CMD, ## __VA_ARGS__)
#define Syserr(x, ...) fprintf(stderr, "%s: " x ": %s\n", CMD, ## __VA_ARGS__, strerror(errno))

#define Info(x...) do { if (verbose) fprintf(stderr, x); } while (0)

typedef unsigned long long u64;

/*
 * Version number is expressed by "i.j.k".
 * i: major version number
 * j: minor version number
 * k: micro version number
 */
struct version_form {
	int	major;
	int	minor;
	int	micro;
};

void version(const char *command_name) __attribute__ ((noreturn));
int find_module_path(void);
u64 scan_param_proc(const char *param_name);
u64 scan_param_sys(int module_path, const char *param_name);
int convert_version_number(struct version_form *ver, const char *ver_str);

#endif
